#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

#include "structs.h"

// #define DEBUG

/*Esta funcion lee los ejercios del archivo "file",
y los deposita en la lista *list, creando esta lista. */
int readfile(char *file, t_list **list);
/* Esta funcion presenta el ejercicio "ejercicio"
al usuario, y retorna como entero la respuesta que ingresa
el usuario.*/
int preguntar(char *ejercicio);
/* Evalua l,a expresion infija almacenada en "ejercicio",
y deposita el resultado en "v". Esta funcion retorna cero
en  caso de que la expresion este correcta, y distinto a cero
si se encuentra algun  error.*/
int revisar(char * ejercicio, int *v);
/* Esta funcion se uso para verificar el funcionamiento
de la implementacion de stack */
void stacktest(void) {
	char c[256];
	t_stack *stack;
	
	stack_new(&stack);
	
	stack_push(stack, "hola1");
	stack_push(stack, "hola2");
	stack_push(stack, "hola3");
	
	stack_get(stack, c);
	printf("  %s\n", c);

	stack_pop(stack, c);
	printf("  %s\n", c);
	stack_pop(stack, c);
	printf("  %s\n", c);
	stack_pop(stack, c);
	printf("  %s\n", c);

	stack_get(stack, c);
	printf("  %s\n", c);

}


/* Programa principal. Discrimina los parametros, para decidir
entre revisar la sintaxis o realizar el test. 
Realiza el test y calcula las notas del usuario*/
int main(int argc, char **argv) {
    t_list *ejercicios;
    int nr_ej, i, respuesta, verdad, b1=0, b2=0, nr;
    
    if (argc < 2) {
        printf("Ingrese el nombre del archivo con los ejercicios\n");
        return -1;
    }
    
    /* Leer ejercicios */	
    nr_ej = readfile(argv[1], &ejercicios);
	
	//stacktest();
	
	/* Verificar sintaxis si es que el usuario lo pidio'. */
	if (argc > 2) {
		if (strcmp(argv[2], "v") == 0)  {
			char *s;
			printf("Verificando sintaxis de archivo de ejercicios\n");
			for (i=0; i<nr_ej; i++) {
				//printf("Revisando ejercicio %d\n", i+1);
				s = list_get(ejercicios, nr_ej-i-1);
				if (revisar(s, &b2)) {
					b1 = -1;
					printf("Error de sintaxis en la linea %d\n\n ---> %s\n", i+1, s);
				}
			}
			/* liberar recursos y retornar con exit status correspondiente. */
			list_free(ejercicios);
			if (b1)
				return -1;
			printf("Archivo con sintaxis correcta.\n");
			return 0;
		}
	}
	
	/* Realizar test. */
	printf("********** Bienvenid@ al test aritmetico *********\n\n");
    nr = nr_ej;
    while (nr_ej--) {
        for (i=0; i<2; i++) {
			/* Verificar y Evaluar expresion. */
			if (revisar(list_get(ejercicios, nr_ej), &verdad)) {
				i = -1;
				nr--;
				break;
			}
			/* Mostrar ejercicio y preguntar por respuesta. */
            respuesta = preguntar(list_get(ejercicios, nr_ej));
            if (respuesta == verdad)
                break;
			if (i == 0)
				printf("El resultado es incorrecto. Intenta denuevo.\n");
        }
		if (i < 2) {
			if (i == 0) {
				printf("Muy bien ! Felicitaciones !\n\n");
				b1++;
			}
			if (i == 1) {
				printf("Muy bien ! Veo que le pones empenio\n\n");
				b2++;
			}	
		} else
			printf("Tu resultado nuevamente es incorrecto. La proxima vez sera .. \n\n");	
    }
	/* Presentar las notas obtendidas por el usuario. */
	printf("Nota 1: %d\n", 100*b1/nr);
	printf("Nota 2: %d\n", 100*(b2+b1)/nr);
	list_free(ejercicios);
    return 0;
}

int readfile(char *file, t_list **list) {
    FILE *fp;
    int nr=0, l;
    char ejercicio[256];
    
    fp = fopen(file, "r");
	if (fp == NULL) {
		printf("Error al abrir el archivo\n");
		exit -1;
	}
    list_new(list);
	while (fgets(ejercicio, 255, fp)) {
		/* si la linea no tiene \n agregar para dejar todas iguales. */
		l = strlen(ejercicio);
		if (ejercicio[l-1] != '\n') {
			ejercicio[l+1] = 0;
			ejercicio[l] = '\n';
		}
		list_add(*list, ejercicio);
		nr++;
    }
    fclose(fp);
	return nr;
}

int preguntar(char *ejercicio) {
	int r;
    printf("Resuelve: %s = ", ejercicio);
	scanf("    %d", &r);
    return r;
}

int decision(char op1, char op2) {
    int o1, o2, o, i;
    char op;

    int d[6][7] = { {4, 1, 1, 1, 1, 1, 5},
                    {2, 2, 2, 1, 1, 1, 2},
                    {2, 2, 2, 1, 1, 1, 2},
                    {2, 2, 2, 2, 2, 1, 2},
                    {2, 2, 2, 2, 2, 1, 2},
                    {5, 1, 1, 1, 1, 1, 3} };
    op = op1;
    for (i=0; i<2; i++) {
        switch (op) {
            case '\n' : o = 1;
				break;
            case '+' : o = 2;
				break;
            case '-' : o = 3;
				break;
            case '*' : o = 4;
				break;
            case '/' : o = 5;
				break;
            case '(' : o = 6;
				break;
            case ')' : o = 7;
				break;				
        }
        if (i == 0)
            o1 = o-1;
        else
            o2 = o-1;
        op = op2;
    }
#ifdef DEBUG
	printf("decision %d, %d -  %d\n", o1+1,  o2+1, d[o1][o2]);
#endif
    return d[o1][o2];
}

int revisar(char * ejercicio, int *resultado) {
    char token[16], optop[16], rpn[256], *tok;
    int i, ii, salir=0, newtok = 1;
    t_stack *op, *eval;
    
    stack_new(&op);
    /* Convertir a RPN */
    i = 0;
	rpn[0] = 0;
    stack_push(op, "\n");
    while (salir == 0) {
		if (newtok) {
			while ((ejercicio[i] == ' ')&&(ejercicio[i] != 0))
				i++;
			if (isdigit(ejercicio[i])) {
				ii = 0;
				while (isdigit(ejercicio[i])&&(ejercicio[i] != 0))
					token[ii++] = ejercicio[i++];
				token[ii] = 0;
			} else {
				token[0] = ejercicio[i];
				token[1] = 0;
				i++;
			}
		}
#ifdef DEBUG
        printf("token :%s\n",  token);
#endif
        if (isdigit(token[0])) {
            strcat(rpn, token);
            strcat(rpn, " "); 
        } else {
            stack_get(op, optop);
#ifdef DEBUG
			printf("optop %s, token %s\n", optop, token);
#endif
            switch (decision(optop[0], token[0])) {
                case 1 : 
                    stack_push(op, token);
					newtok = 1;
                    break;
                case 2 :
                    stack_pop(op, optop);
                    strcat(rpn, optop);
                    strcat(rpn, " ");
					newtok = 0;
                    break;
                case 3 : 
                    stack_pop(op, optop);
					newtok = 1;
                    break;
                case 4 :
					stack_pop(op, optop);
                    while ((optop[0] != '\n')&&(optop[0] != 0)) {
						strcat(rpn, optop);
						strcat(rpn, " ");
						stack_pop(op, optop);
					}
					salir = 1;
                    break;
                case 5 : 
                default :
                    //printf("Error de syntaxis en la linea");
                    salir = -1;
                    break;
            }
        }
#ifdef DEBUG
		printf("RPN parcial : %s\n", rpn);
#endif
    }
    stack_free(op);
	if (salir == -1)
		return -1;
#ifdef DEBUG    
	printf("RPN : %s\n", rpn);
#endif
    /* Evaluar string en notacion RPN*/
    stack_new(&eval);
	tok = strtok(rpn, " ");
    while (tok != NULL) {
		//printf("tok %s \n", tok);
        if (isdigit(*tok))
            stack_push(eval, tok);
        else {
			stack_pop(eval, optop);
			if (eval == (eval->next))
				return -1;
			stack_pop(eval, token);
			//printf("hola3 %s, %s\n", token, optop);
            switch (*tok) {
                case '+' :
                    ii = atoi(token) + atoi(optop);
                    break;
                case '-' :
                    ii = atoi(token) - atoi(optop);
                    break;
                case '*' :
                    ii = atoi(token) * atoi(optop);
                    break;
                case '/' :
                    ii = atoi(token) / atoi(optop);
                    break;                
            }
            sprintf(token, "%d", ii);
            stack_push(eval, token);
        }
        tok = strtok(NULL, " ");
    }
    stack_pop(eval, token);
    *resultado = atoi(token);
    stack_free(eval);
    return  0;
}
